function fai_wait(id,mode)
	if vai_timer[id]>0 then
		vai_timer[id]=vai_timer[id]-1
	else
		vai_mode[id]=0
	end
end

function fai_angledelta(a1,a2)
	local d=(a2-a1)%360
	if d<-180 then d=d+360 end
	if d>180 then d=d-360 end
	return d
end

function fai_angleto(x1,y1,x2,y2)
	return math.deg(math.atan2(x2-x1,y1-y2))
end

function fai_contains(t,e)
	for _, value in pairs(t) do
		if value == e then
			return true
		end
	end
	return false
end

function fai_playerslotitems(id,slot)
	local items=playerweapons(id)
	for i=1,#items do
		if itemtype(items[i],"slot")==slot then
			return true
		end
	end
	return false
end

function fai_playertypeitems(id,type)
	local items=playerweapons(id)
	for i=1,#items do
		if itemtype(items[i],"weapontype")==type then
			return true
		end
	end
	return false
end

function fai_walkaim(id)	
	local x=player(id,"x")
	local y=player(id,"y")		
	local angle=math.deg(math.atan2(x-(vai_px[id] or x),(vai_py[id] or y)-y))
	ai_aim(id,x+math.sin(math.rad(angle))*150,y-math.cos(math.rad(angle))*150)
	if vai_px[id]~=x then vai_px[id]=x end
	if vai_py[id]~=y then vai_py[id]=y end	
end

function fai_enemies(id1,id2)
	if player(id1,"team")~=player(id2,"team") then
		if player(id1,"team")>=2 and player(id2,"team")>=2 then
			return false
		else
			return true
		end
	elseif vai_set_gm==1 then
		return true
	end
	return false
end

function fai_randommate(id)
	local team=player(id,"team")
	if team>2 then
		team=2
	end
	local players=player(0,"team"..team.."living")
	if #players==0 then
		return 0
	end
	for i=1,10 do
		local randid=math.random(1,#players)
		if players[randid]~=id then
			return players[randid]
		end
	end
	return 0
end

function fai_randomadjacent(id)
	px=player(id,"tilex")
	py=player(id,"tilex")	
	for i=1,2 do
		x=px+math.random(-64,64)
		y=py+math.random(-64,64)	
		if (x~=px or y~=py) then
			if tile(px,py,"walkable") and tile(px,py,"frame")~=0 and tile(px,py,"frame")~=46 and tile(px,py,"frame")~=47 and tile(px,py,"property")<50 then
				vai_destx[id]=x
				vai_desty[id]=y
				return
			end
		end
	end
end